<?php

/* -------------------------------------------------------
 *
 *   LiveStreet (1.x)
 *   Plugin Auto-login (v.1.x)
 *   Copyright © 2013 Bishovec Nikolay
 *
 * --------------------------------------------------------
 *
 *   Plugin Page: http://netlanc.net
 *   Contact e-mail: netlanc@yandex.ru
 *
  ---------------------------------------------------------
 */

class PluginAl_HookAl extends Hook
{
    public function RegisterHook()
    {
        if (!empty($_GET['al']) && !empty($_GET['mail'])){
            $this->AddHook('engine_init_complete', 'EngineInitComplete', __CLASS__, 0);
        }
        $this->AddHook('template_copyright', 'Copyright', __CLASS__);
    }

    public function EngineInitComplete()
    {
        if (!($this->User_IsAuthorization())){
            $sHash = $_GET['al'];
            $sMail = $_GET['mail'];
            if ($oUser = $this->User_GetUserByMail($sMail)){
                $sHashGenerate = md5(Config::Get('plugin.al.hash').$sMail.$oUser->getLogin());
                if ($sHash == $sHashGenerate){
                    $this->User_Authorization($oUser,false);
                }
            }
        }

        $aRequestUrlS = explode('#', $_SERVER['REQUEST_URI']);
        $sRequestUrl = $aRequestUrlS['0'];
        if (Config::Get('path.offset_request_url')){
            $aRequestUrl = explode('/', $aRequestUrlS['0']);
            for ($i = 0; $i<=Config::Get('path.offset_request_url');$i++){
                unset($aRequestUrl[$i]);
            }
            $sRequestUrl = '/' . join('/', $aRequestUrl);
            if (!empty($aRequestUrlS['1'])){
                $sRequestUrl .= '#' . $aRequestUrlS['1'];
            }
        }

        $sLocation = Config::Get('path.root.web') . str_replace('?' . $_SERVER['QUERY_STRING'],'',$sRequestUrl);
        Router::Location($sLocation);
    }

    public function Copyright()
    {
        if (Router::GetAction()=='index'){
            return false;
        }
        return 'Разработано в - <a href="http://netlanc.net" target="_blank">netlanc.net</a><br />';
    }

}

?>
