<?php

/* -------------------------------------------------------
 *
 *   LiveStreet (1.x)
 *   Plugin Auto-login (v.1.x)
 *   Copyright © 2013 Bishovec Nikolay
 *
 * --------------------------------------------------------
 *
 *   Plugin Page: http://netlanc.net
 *   Contact e-mail: netlanc@yandex.ru
 *
  ---------------------------------------------------------
 */

class PluginAl_ModuleNotify extends PluginAl_Inherit_ModuleNotify
{

    public function Send($oUserTo,$sTemplate,$sSubject,$aAssign=array(),$sPluginName=null) {
        if ($oUserTo instanceof ModuleUser_EntityUser) {
            $sMail=$oUserTo->getMail();
            $sName=$oUserTo->getLogin();
        } else {
            $sMail=$oUserTo;
            $sName='';
        }

        $sTemplatePath = $this->GetTemplatePath($sTemplate,$sPluginName);

        if (in_array($sTemplate, Config::Get('plugin.al.tpl'))){

            if ($oUserTo instanceof ModuleUser_EntityUser) {
                $oUserSendMAil = $oUserTo;
            } else {
                $oUserSendMAil = $this->User_GetUserByMail($oUserTo);
                $sName=$oUserSendMAil->getLogin();
            }

            $sHash=md5(Config::Get('plugin.al.hash').$sMail.$oUserSendMAil->getLogin());

            $aAssign['sAl'] = '?al=' . $sHash . '&mail=' . $sMail;
        }

        /**
         * Передаём в шаблон переменные
         */
        foreach ($aAssign as $k=>$v) {
            $this->oViewerLocal->Assign($k,$v);
        }
        /**
         * Формируем шаблон
         */
        $sBody=$this->oViewerLocal->Fetch($sTemplatePath);
        /**
         * Если в конфигураторе указан отложенный метод отправки,
         * то добавляем задание в массив. В противном случае,
         * сразу отсылаем на email
         */
        if(Config::Get('module.notify.delayed')) {
            $oNotifyTask=Engine::GetEntity(
                'Notify_Task',
                array(
                    'user_mail'      => $sMail,
                    'user_login'     => $sName,
                    'notify_text'    => $sBody,
                    'notify_subject' => $sSubject,
                    'date_created'   => date("Y-m-d H:i:s"),
                    'notify_task_status' => self::NOTIFY_TASK_STATUS_NULL,
                )
            );
            if(Config::Get('module.notify.insert_single')) {
                $this->aTask[] = $oNotifyTask;
            } else {
                $this->oMapper->AddTask($oNotifyTask);
            }
        } else {
            /**
             * Отправляем мыло
             */
            $this->Mail_SetAdress($sMail,$sName);
            $this->Mail_SetSubject($sSubject);
            $this->Mail_SetBody($sBody);
            $this->Mail_setHTML();
            $this->Mail_Send();
        }
    }

}

?>
